(($) => {
	"use strict";

	const $_buttonsT = $(`<div class="__custome_buttons"></div>`);
	const $_buttonT = $(`<div class="__custome_button"></div>`);

	function isBase64Encoded(str) {
		return /^[A-Za-z0-9+/=]+$/.test(str) && str.length % 4 === 0;
	}

	function sleep(time=1000) {
		return new Promise((resolve) => { resolve(); }, time)
	}

	function createCustomeButtons(record) {
		// テーブルのIDリストを取得
	  const subTables = cybozu.data.page.SCHEMA_DATA.subTable;

	  for (const id in subTables) {
	    const code = subTables[id].var;
	    const len = record[code].value.length;

			// テーブル要素取得
			const $operations = $(`table.subtable-${id} tbody .subtable-operation-gaia`).length
				? $(`table.subtable-${id} tbody .subtable-operation-gaia`)
				: $(`table.subtable-${id} tbody .subtable-operation-gaia-old`);

			$operations.each((i, elm) => {
				$(elm).find(".__custome_buttons").remove();
				const $customeButtons = $_buttonsT.clone().appendTo($(elm));

				// 複製
				$_buttonT.clone()
					.addClass("__copy")
					.attr("data-index", i)
					.attr("title", "行の複製")
					.append($('<i class="fa-solid fa-clone"></i>'))
					.appendTo($customeButtons)
					.on("click", (evt) => {
						const index = Number(evt.target.dataset.index);
						const record = kintone.app.record.get().record;
						const table = record[code].value;
						const row = table[index];
						table.splice(index + 1, 0, row);
						kintone.app.record.set({record: record});
						createCustomeButtons(record);
					});

				// 上に移動
				if (i > 0) {
					$_buttonT.clone()
						.addClass("__up")
						.attr("data-index", i)
						.attr("title", "ひとつ上へ")
						.append($('<i class="fa-solid fa-turn-up"></i>'))
						.appendTo($customeButtons)
						.on("click", (evt) => {
							const index = Number(evt.target.dataset.index);
							const record = kintone.app.record.get().record;
							const table = record[code].value;
							const row = table[index];
							table.splice(index, 1);
							table.splice(index - 1, 0, row);
							kintone.app.record.set({record: record});
						});
				}

				// 下に移動
				if ((i + 1) != len) {
					$_buttonT.clone()
						.addClass("__down")
						.attr("data-index", i)
						.attr("title", "ひとつ下へ")
						.append($('<i class="fa-solid fa-turn-down"></i>'))
						.appendTo($customeButtons)
						.on("click", (evt) => {
							const index = Number(evt.target.dataset.index);
							const record = kintone.app.record.get().record;
							const table = record[code].value;
							if (index == (table.length - 1)) {
								return;
							}
		
							const row = table[index];
							table.splice(index, 1);
							table.splice(index + 1, 0, row);
							kintone.app.record.set({record: record});
						});
				}

			});
		}
	}

	kintone.events.on([
		"app.record.create.show",
		"app.record.edit.show"
	], async (e) => {
		const plugin_id = "nceecjcncgdmlpknkbekckdapjealkjd";

		try {
			const _config = kintone.plugin.app.getConfig(plugin_id);
			const _fields = _config.fields
			? isBase64Encoded(_config.fields)
				? JSON.parse(LZString.decompressFromBase64(_config.fields))
				: JSON.parse(_config.fields)
			: {};
			const _layouts = _config.layouts
			? isBase64Encoded(_config.layouts)
				? JSON.parse(LZString.decompressFromBase64(_config.layouts))
				: JSON.parse(_config.layouts)
			: [];
			const tables = _layouts.filter(x => x.table);
			const table_fields = {};
			for (const subtable of tables) {
				if (subtable.maxRow <= 1) continue;
				if (!_fields.SUBTABLE.find(x => x.code == subtable.table)) continue;
		
				if (table_fields[subtable.table]) {
					if (table_fields[subtable.table] < subtable.maxRow) {
						table_fields[subtable.table] = subtable.maxRow;
					}
				} else {
					table_fields[subtable.table] = subtable.maxRow;
				}
			}

			for (const code in table_fields) {
				const id = setInterval(() => {
					const record = kintone.app.record.get().record;
					if (record[code].value.length >= table_fields[code]) {
						clearInterval(id);
						createCustomeButtons(e.record);
					}
				}, 50);
			}

		} catch(err) {
			createCustomeButtons(e.record);
		}

		$(document).on("click", "table td .add-row-image-gaia, table td .add-row-image-gaia", (evt) => {
			const record = kintone.app.record.get().record;
			createCustomeButtons(record);
		});
	});

})(jQuery);